Index: /pjproject/branches/projects/cli/pjlib-util/src/pjlib-util/cli_telnet.c
===================================================================
--- /pjproject/branches/projects/cli/pjlib-util/src/pjlib-util/cli_telnet.c	(revision 4298)
+++ /pjproject/branches/projects/cli/pjlib-util/src/pjlib-util/cli_telnet.c	(revision 4299)
@@ -214,11 +1225,11 @@
 				          pj_ssize_t sent)
 {
-    struct cli_telnet_sess *sess = (struct cli_telnet_sess *)
-                                    pj_activesock_get_user_data(asock);
+    cli_telnet_sess *sess = (cli_telnet_sess *)
+			    pj_activesock_get_user_data(asock);
 
     PJ_UNUSED_ARG(op_key);
 
     if (sent <= 0) {
-        pj_cli_end_session(&sess->base);
+        pj_cli_sess_end_session(&sess->base);
         return PJ_FALSE;
     }
@@ -232,5 +1243,5 @@
         if (telnet_sess_send2(sess, sess->buf, len) != PJ_SUCCESS) {
             pj_mutex_unlock(sess->smutex);
-            pj_cli_end_session(&sess->base);
+            pj_cli_sess_end_session(&sess->base);
             return PJ_FALSE;
         }
@@ -248,8 +1259,9 @@
 			                  pj_size_t *remainder)
 {
-    struct cli_telnet_sess *sess = (struct cli_telnet_sess *)
-                                    pj_activesock_get_user_data(asock);
+    cli_telnet_sess *sess = (cli_telnet_sess *)
+                            pj_activesock_get_user_data(asock);
     struct cli_telnet_fe *tfe = (struct cli_telnet_fe *)sess->base.fe;
-    char *cdata = (char*)data;
+    unsigned char *cdata = (unsigned char*)data;    
+    pj_status_t is_valid = PJ_TRUE;
 
     PJ_UNUSED_ARG(size);
@@ -257,5 +1269,5 @@
 
     if (status != PJ_SUCCESS && status != PJ_EPENDING) {
-        pj_cli_end_session(&sess->base);
+        pj_cli_sess_end_session(&sess->base);
         return PJ_FALSE;
     }
@@ -266,62 +1278,87 @@
     pj_mutex_lock(sess->smutex);
 
-    if (*cdata == 8) {                          // Backspace
-        if (sess->len > 0)
-            sess->len--;
-        if (telnet_sess_send2(sess, " \b", 2) != PJ_SUCCESS)
-            goto on_exit;
-    } else {
-        if (sess->len < PJ_CLI_MAX_CMDBUF - 1)
-            sess->rcmd[sess->len++] = *cdata;
-        if (*cdata == '\n') {
-            /* Trim trailing newlines */
-            for (; sess->len > 0;) {
-                if (sess->rcmd[sess->len - 1] == '\n' ||
-                    sess->rcmd[sess->len - 1] == '\r')
-                    sess->rcmd[--sess->len] = 0;
-                else
-                    break;
-            }
-            if (sess->len > 0 && sess->rcmd[sess->len - 1] != 0)
-                sess->rcmd[sess->len++] = 0;
-
-            /* If a password is necessary, check whether the supplied password
-             * is correct.
-             */
-            if (!sess->authorized && 
-                ((struct cli_telnet_fe *)sess->base.fe)->cfg.passwd.slen > 0)
-            {
-                if (pj_strcmp2(&tfe->cfg.passwd, sess->rcmd)) {
-                    pj_str_t str = pj_str("Wrong password!\r\n");
-
-                    telnet_sess_send(sess, &str);
-                    goto on_exit;
-                } else {
-                    /* Password is correct, send welcome message */
-                    if (telnet_sess_send(sess, &tfe->cfg.welcome_msg)
-                        != PJ_SUCCESS)
-                    {
-                        goto on_exit;
-                    }
-                    sess->authorized = PJ_TRUE;
-                }
-            } else {
-                pj_status_t status;
-                
-                pj_mutex_unlock(sess->smutex);
-                status = pj_cli_exec(&sess->base, sess->rcmd, NULL);
-                if (status == PJ_CLI_EEXIT)
-                    return PJ_FALSE;
-                pj_mutex_lock(sess->smutex);
-            }
-            sess->len = 0;
-        } else if (!sess->authorized && 
-            ((struct cli_telnet_fe *)sess->base.fe)->cfg.passwd.slen > 0 &&
-            *cdata != '\r')
-        {
-            if (telnet_sess_send2(sess, "\b ", 2) != PJ_SUCCESS)
-                goto on_exit;
-        }
-
+    switch (sess->parse_state) {
+	case ST_CR:
+	    sess->parse_state = ST_NORMAL;
+	    if (*cdata == 0 || *cdata == '\n')				
+		pj_mutex_unlock(sess->smutex);
+		is_valid = handle_return(sess);
+		if (!is_valid)		    
+		    return PJ_FALSE;
+		pj_mutex_lock(sess->smutex);	
+		break;
+	case ST_NORMAL:
+	    if (*cdata == IAC) {
+		sess->parse_state = ST_IAC;
+	    } else if (*cdata == '\b') {
+		is_valid = handle_backspace(sess, cdata);
+	    } else if (*cdata == 27) {		    
+		sess->parse_state = ST_ESC;
+	    } else { 
+		if (recv_buf_insert(sess->rcmd, cdata)) {
+		    if (*cdata == '\r') {
+			sess->parse_state = ST_CR;
+		    } else if ((*cdata == '\t') || (*cdata == '?')) {
+			is_valid = handle_tab(sess);
+		    } else if (*cdata > 31 && *cdata < 127) {
+			is_valid = handle_alfa_num(sess, cdata);
+		    }
+		} else {
+		    is_valid = PJ_FALSE;
+		}
+	    }
+	    break;
+	case ST_ESC:
+	    if (*cdata == 91) {		
+		sess->parse_state = ST_VT100;
+	    } else {
+		sess->parse_state = ST_NORMAL;
+	    }
+	    break;
+	case ST_VT100:
+	    sess->parse_state = ST_NORMAL;
+	    is_valid = process_vt100_cmd(sess, cdata);
+	    break;
+	case ST_IAC:
+	    switch ((unsigned) *cdata) {
+		case DO:
+		    sess->parse_state = ST_DO;
+		    break;
+		case DONT:
+		    sess->parse_state = ST_DONT;
+		    break;
+		case WILL:
+		    sess->parse_state = ST_WILL;
+		    break;
+		case WONT:
+		    sess->parse_state = ST_WONT;
+		    break;
+		default:
+		    sess->parse_state = ST_NORMAL;
+		    break;
+	    }
+	    break;
+	case ST_DO:
+	    receive_do(sess, *cdata);
+	    sess->parse_state = ST_NORMAL;
+	    break;
+	case ST_DONT:
+	    receive_dont(sess, *cdata);
+	    sess->parse_state = ST_NORMAL;
+	    break;
+	case ST_WILL:
+	    receive_will(sess, *cdata);
+	    sess->parse_state = ST_NORMAL;
+	    break;
+	case ST_WONT:
+	    receive_wont(sess, *cdata);
+	    sess->parse_state = ST_NORMAL;
+	    break;
+	default:
+	    sess->parse_state = ST_NORMAL;
+	    break;
+    }
+    if (!is_valid) {
+	send_bell(sess);
     }
 
@@ -329,9 +1366,4 @@
 
     return PJ_TRUE;
-
-on_exit:
-    pj_mutex_unlock(sess->smutex);
-    pj_cli_end_session(&sess->base);
-    return PJ_FALSE;
 }
 
@@ -345,5 +1377,5 @@
     pj_status_t sstatus;
     pj_pool_t *pool;
-    struct cli_telnet_sess *sess;
+    cli_telnet_sess *sess;
     pj_activesock_cb asock_cb;
 
@@ -364,5 +1396,5 @@
     }
 
-    sess = PJ_POOL_ZALLOC_T(pool, struct cli_telnet_sess);
+    sess = PJ_POOL_ZALLOC_T(pool, cli_telnet_sess);
     sess->pool = pool;
     sess->base.fe = &fe->base;
@@ -373,4 +1405,8 @@
     asock_cb.on_data_read = &telnet_sess_on_data_read;
     asock_cb.on_data_sent = &telnet_sess_on_data_sent;
+    sess->rcmd = PJ_POOL_ZALLOC_T(pool, telnet_recv_buf);
+    sess->history = PJ_POOL_ZALLOC_T(pool, struct cmd_history);
+    pj_list_init(sess->history);
+    sess->active_history = sess->history;
 
     sstatus = pj_mutex_create_recursive(pool, "mutex_telnet_sess",
@@ -387,21 +1423,25 @@
     }
 
-    /* Prompt for password if required, otherwise directly send
-     * a welcome message.
-     */
-    if (fe->cfg.passwd.slen) {
-        pj_str_t pwd = pj_str("Password: ");
-        if (telnet_sess_send(sess, &pwd) != PJ_SUCCESS)
-            goto on_exit;
-    } else {
-        if (pj_strlen(&fe->cfg.welcome_msg)) {
-            if (telnet_sess_send(sess, &fe->cfg.welcome_msg) != PJ_SUCCESS)
-                goto on_exit;
-        } else {
-            if (telnet_sess_send2(sess, " \b", 2) != PJ_SUCCESS)
-                goto on_exit;
-        }
-        sess->authorized = PJ_TRUE;
-    }
+    pj_memset(sess->telnet_option, 0, sizeof(sess->telnet_option));
+    set_local_option(sess, TRANSMIT_BINARY, PJ_TRUE);
+    set_local_option(sess, STATUS, PJ_TRUE);
+    set_local_option(sess, SUPPRESS_GA, PJ_TRUE);
+    set_local_option(sess, TIMING_MARK, PJ_TRUE);
+    set_local_option(sess, TERM_SPEED, PJ_TRUE);
+    set_local_option(sess, TERM_TYPE, PJ_TRUE);
+
+    set_peer_option(sess, TRANSMIT_BINARY, PJ_TRUE);
+    set_peer_option(sess, SUPPRESS_GA, PJ_TRUE);
+    set_peer_option(sess, STATUS, PJ_TRUE);
+    set_peer_option(sess, TIMING_MARK, PJ_TRUE);
+    set_peer_option(sess, ECHO, PJ_TRUE);    
+
+    send_cmd_do(sess, SUPPRESS_GA);
+    send_cmd_will(sess, ECHO);
+    send_cmd_will(sess, STATUS);   
+    send_cmd_will(sess, SUPPRESS_GA);
+
+    /* Send prompt string */
+    telnet_sess_send(sess, &fe->cfg.prompt_str);
 
     /* Start reading for input from the new telnet session */
@@ -462,5 +1502,4 @@
     fe->base.type = PJ_CLI_TELNET_FRONT_END;
     fe->base.op->on_write_log = &cli_telnet_fe_write_log;
-//    fe->base.op->on_quit = &cli_telnet_fe_quit;
     fe->base.op->on_destroy = &cli_telnet_fe_destroy;
     fe->pool = pool;
@@ -497,4 +1536,14 @@
         PJ_LOG(3, (THIS_FILE, "CLI telnet daemon listening at port %d",
                fe->cfg.port));
+	
+	if (fe->cfg.prompt_str.slen == 0) {
+	    pj_str_t prompt_sign = {"> ", 2};
+	    char *prompt_data = pj_pool_alloc(fe->pool, 
+					      pj_gethostname()->slen+2);
+	    fe->cfg.prompt_str.ptr = prompt_data;
+
+	    pj_strcpy(&fe->cfg.prompt_str, pj_gethostname());
+	    pj_strcat(&fe->cfg.prompt_str, &prompt_sign);
+	}	
     } else {
         PJ_LOG(3, (THIS_FILE, "Failed binding the socket"));
Index: /pjproject/branches/projects/cli/pjsip-apps/src/samples/clidemo.c
===================================================================
--- /pjproject/branches/projects/cli/pjsip-apps/src/samples/clidemo.c	(revision 4298)
+++ /pjproject/branches/projects/cli/pjsip-apps/src/samples/clidemo.c	(revision 4299)
@@ -34,5 +34,5 @@
  * Default: 1
  */
-#define USE_RANDOM_PORT 1
+#define USE_RANDOM_PORT 0
 
 struct cmd_xml_t {
@@ -82,8 +82,8 @@
 }
 
-static pj_status_t quit(pj_cli_cmd_val *cval)
+static pj_status_t quit_app(pj_cli_cmd_val *cval)
 {
     PJ_UNUSED_ARG(cval);
-    pj_cli_end_session(cval->sess);
+    pj_cli_quit(cval->sess->fe->cli, cval->sess, PJ_FALSE);
 
     return PJ_CLI_EEXIT;
@@ -92,25 +92,32 @@
 static struct cmd_xml_t cmd_xmls[] = {
     {"<CMD name='sayhello' id='1' sc='  ,h , ,, sh  ,' desc='Will say hello'>"
-     "  <ARGS>"
      "    <ARG name='whom' type='text' desc='Whom to say hello to'/>"
-     "  </ARGS>"
      "</CMD>",
      &sayhello},
     {"<CMD name='saybye' id='2' sc='b,sb' desc='Will say bye'>"
-     "  <ARGS>"
      "    <ARG name='whom' type='text' desc='Whom to say bye to'/>"
-     "  </ARGS>"
      "</CMD>",
      &saybye},
-    {"<CMD name=' say ' id='3' sc='s' desc='Will say something'>"
-     "  <ARGS>"
+    {"<CMD name='saymsg' id='3' sc='s' desc='Will say something'>"
      "    <ARG name='msg' type='text' desc='Message to say'/>"
      "    <ARG name='whom' type='text' desc='Whom to say to'/>"
-     "  </ARGS>"
      "</CMD>",
      &say},
-    {"<CMD name='quit' id='999' sc='q' desc='Quit the application'>"
-     "</CMD>",
-     &quit},
+    {"<CMD name='vid' id='1' desc='Video Command'>"
+     "   <CMD name='help' id='2' desc='Show Help' />"
+     "   <CMD name='enable' id='3' desc='Enable Video' />"
+     "   <CMD name='disable' id='4' desc='Disable Video' />"
+     "   <CMD name='call' id='5' desc='Video call' >"
+     "            <CMD name='add' id='6' desc='Add Call' />"
+     "            <CMD name='cap' id='7' desc='Capture Call' >"
+     "               <ARG name='streamno' type='int' desc='Stream Number' id='1'/>"
+     "               <ARG name='devid' type='int' desc='Device Id' optional='1' id='2'/>"
+     "            </CMD>"
+     "   </CMD>"     
+     "</CMD>",
+     NULL},
+    {"<CMD name='quit_app' id='999' sc='qa' desc='Quit the application'>"
+     "</CMD>",
+     &quit_app},
 };
 
@@ -128,5 +135,5 @@
     pj_str_t xml;
     pj_status_t status;
-    int i;
+    int i;        
 
     pj_init();
@@ -150,7 +157,7 @@
      */
     for (i = 0; i < sizeof(cmd_xmls)/sizeof(cmd_xmls[0]); i++) {
-        xml = pj_str(cmd_xmls[i].xml);
+        xml = pj_str(cmd_xmls[i].xml);	
         status = pj_cli_add_cmd_from_xml(cli, NULL, &xml, 
-                                         cmd_xmls[i].handler, NULL);
+                                         cmd_xmls[i].handler, NULL, NULL);
         if (status != PJ_SUCCESS)
 	    goto on_return;
@@ -210,13 +217,11 @@
      */
     for (;;) {
-	char cmdline[PJ_CLI_MAX_CMDBUF];
         pj_status_t status;
 
-        status = pj_cli_console_readline(sess, cmdline, sizeof(cmdline));
+        status = pj_cli_console_process(sess);
 	if (status != PJ_SUCCESS)
 	    break;
 
-//        pj_ansi_strcpy(cmdline, "sayhello {Teluu Inc.}");
-	status = pj_cli_exec(sess, cmdline, NULL);
+	//pj_ansi_strcpy(cmdline, "sayhello {Teluu Inc.}");	
 	if (status == PJ_CLI_EEXIT) {
 	    /* exit is called */
Index: /pjproject/branches/projects/cli/pjsip-apps/src/samples/debug.c
===================================================================
--- /pjproject/branches/projects/cli/pjsip-apps/src/samples/debug.c	(revision 4298)
+++ /pjproject/branches/projects/cli/pjsip-apps/src/samples/debug.c	(revision 4299)
@@ -29,4 +29,4 @@
  *  #include "playfile.c"
  */
-#include "icedemo.c"
+#include "clidemo.c"
 
